unit blocks_1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Mulblo, WBlib, BlockI, StdCtrls, ExtCtrls, b_cons, ComCtrls, jpeg;

const
  maxcols = 30; //maximum number of vertex blocks in a row

type
  TBlocksForm = class(TForm)
    BRestart: TButton;
    BStop: TButton;
    LIteration: TLabel;
    LStatus: TLabel;
    LIdent: TLabel;
    LColor: TLabel;
    LMinimal: TLabel;
    TitleLabel: TLabel;
    ProgressBar: TProgressBar;
    Iteration: TEdit;
    color: TEdit;
    LSequence: TLabel;
    sequence: TEdit;
    SequenceBounds: TLabel;
    IterationBounds: TLabel;
    BlocksPlace: TBevel;
    Image1: TImage;
    procedure FormActivate(Sender: TObject);
    procedure BRestartClick(Sender: TObject);
    procedure BStopClick(Sender: TObject);
  private
    { Private declarations }
  public
    pc : array of TPanel;
    { Public declarations }
  end;

var
  BlocksForm: TBlocksForm;
  gm: MultiGibbs;
  i: integer;
  version:        string;
  outf,outf1:     textfile;   (* output files *)
  logfile, outfn, outfn1:  string; (* names of output files *)
  restart1, stop1, starting : boolean;
  colorset: array[1..cmax] of tcolor;

implementation

{$R *.DFM}

procedure TBlocksForm.FormActivate(Sender: TObject);
//var i, rownr, colnr: integer;
//  PB : TPanel;
procedure PrepareForm;
var i, j, rownr, colnr, onesequence, onecolor: integer;
 df: textfile;
 pr: real;
 xx: array[1..400,1..400] of byte;
 nn: integer;
begin
  if (gm.n <= nformax) then nforform := gm.n else nforform := nformax;

  {
(*  for generating some artificial block matrices : *)
assignfile(df,'m400.dat');
rewrite(df);
nn := 400;
for i:=1 to nn do begin
  for j:=1 to nn do begin
  if ((3*i < nn) and (3*j < nn)) then pr := 0.45 else pr := 0.55;
  if (random < pr) then xx[i,j] := 1 else xx[i,j] := 0;
  end;
  xx[i,i] := 0;
 end;
for i:=1 to nn do begin
  for j:=1 to nn do begin
//    if (i < j) then
    write(df,xx[i,j]:2);
    // else write(df,xx[j,i]:2);
  end;
 writeln(df);
 end;

 closefile(df);
 }


 OptMessage3('Creating block pictures');
 SetLength(pc,nforform+2);
 Application.ProcessMessages;

 for i:=1 to cmax do begin
   j := i mod 12;
   case j of
   1: colorset[i] := clMaroon;
   2: colorset[i] := clOlive;
   3: colorset[i] := clYellow;
   4: colorset[i] := clTeal;
   5: colorset[i] := clPurple;
   6: colorset[i] := clRed;
   7: colorset[i] := clFuchsia;
   8: colorset[i] := clGreen;
   9: colorset[i] := clWhite;
  10: colorset[i] := clAqua;
  11: colorset[i] := clBlue;
   0: colorset[i] := clLime;
   end; (* case *)
  end;

 for i:=1 to nforform do
  begin
    pc[i]:=TPanel.Create(Self);
    pc[i].Parent:=Self;
    pc[i].visible:=false;
    pc[i].width:=17;
    pc[i].height:=17;
    rownr:=(i-1) div maxcols;
    colnr:=(i-1) mod maxcols;
    pc[i].top:=BlocksPlace.top + rownr*17;
    pc[i].left:=BlocksPlace.left+17*colnr;
    pc[i].color:=colorset[1+(i mod cmax)];
    pc[i].caption:=inttostr(i);
    pc[i].hint:=inttostr(i);
    pc[i].showhint:=true;
    pc[i].visible:=true;
  end;
  with gm do begin
    onesequence := nrun0+nrun1;
    if both then onesequence := 2*onesequence;
    onecolor := multi*onesequence;
    ProgressBar.Max := (comax-comin+1)*onecolor;
    if (comin = comax) then
     Lcolor.caption := 'colors  (constant)' else
     Lcolor.caption := 'colors  ('+inttostr(comin)+'-'+inttostr(comax)+')';
    if (not multiple) then begin
(*      Sequence.Enabled := false; *)
      Sequence.Visible := false;
      LSequence.Visible := false;
(*      LSequence.Enabled := false;
      SequenceBounds.Enabled := false; *)
      SequenceBounds.Visible := false;
     end else SequenceBounds.Caption := '(1-'+inttostr(multi)+')';
      IterationBounds.caption := '(1-'+inttostr(startmax)+')';
     BlocksPlace.width := maxcols*17;
//     if (nforform > 60) then BlocksPlace.Height := 17*((nforform + 29) div 30);
      BlocksPlace.Height := 17*(rownr+1);
     Caption := 'BLOCKS   '+proname;
   end;
 Application.ProcessMessages;
end; (* PrepareForm *)
begin
  stop1:=false;
  restart1:=false;
  logfile:='blocks.log';
  BRestart.Enabled:=false; 

  if FileExists(logfile) then
    begin
    assignfile(lf,logfile);
    append(lf);
    end
   else
    begin
    assignfile(lf,logfile);
    rewrite(lf);
    end;

  with gm do
  begin
    initialise(outf, outf1, outfn , outfn1);
    if not stopped then readinfile(outf, outf1, outfn , outfn1);
    if not stopped then SetArrays(outf);
    if not stopped then readdata(outf, outf1, outfn , outfn1);
    if not stopped then SetMulArrays(outf);
    if not stopped then PrepareForm;
    if not stopped then Gibbs(outf, outf1, outfn , outfn1);
    stopsthis(outf, outf1);
  end; (* with gm *)
  closefile(lf);
  close;
  finalize(pc);
end;

procedure TBlocksForm.BRestartClick(Sender: TObject);
begin
  if MessageDlg(
  'Are you sure you want to restart the post-convergence runs of this Gibbs sequence?',
                mtConfirmation,[mbYes, mbNo],1)
  = mrYes then restart1 := true;
end;

procedure TBlocksForm.BStopClick(Sender: TObject);
var txt: string;
begin
  if starting then txt := 'Are you sure you want to interrupt search for starting values?'
   else txt :=  'Are you sure you want to stop this program?';
  if MessageDlg(txt, mtConfirmation,[mbYes, mbNo],1) = mrYes
   then  stop1:=true
end;

end.
